"use strict";
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const _1 = __importStar(require("."));
const react_1 = require("react");
const utils_1 = require("./utils");
exports.useQuery = (arg1, arg2) => {
    const context = react_1.useContext(_1.FetchContext);
    utils_1.useURLRequiredInvariant(!!context.url && Array.isArray(arg1), 'useQuery');
    utils_1.useURLRequiredInvariant(!!context.url && utils_1.isString(arg1) && !arg2, 'useQuery', 'OR you need to do useQuery("https://example.com", `your graphql query`)');
    // regular no context: useQuery('https://example.com', `graphql QUERY`)
    let url = arg1;
    let QUERY = arg2;
    // tagged template literal with context: useQuery`graphql QUERY`
    if (Array.isArray(arg1) && context.url) {
        utils_1.invariant(!arg2, 'You cannot have a 2nd argument when using tagged template literal syntax with useQuery.');
        url = context.url;
        QUERY = arg1[0];
        // regular with context: useQuery(`graphql QUERY`)
    }
    else if (arg1 && !arg2 && context.url) {
        url = context.url;
        QUERY = arg1;
    }
    const request = _1.default(url);
    const query = react_1.useCallback((inputs) => request.query(QUERY, inputs), []);
    return Object.assign([request.data, request.loading, request.error, query], Object.assign({}, request, { query }));
};
//# sourceMappingURL=useQuery.js.map